/**********************************************************************-*-C-*-
 *
 * portlib.h - This file was part of `xradio', now is part of `ictester'
 *
 * Copyright (C) 1996 Pat Thoyts (thoyts@bsa.bristol.ac.uk)
 *
 * Changes: copyright (C) 2001, 2002 Silvio Klaic (sklaic@student.math.hr)
 *
 *****************************************************************************/

#ifndef _PORTLIB_H
#define _PORTLIB_H

#include <stdio.h>

/*Define this for debugging writes to ports.*/
/*#define DEBUG_PORTLIB 1 */

#ifdef __minix
_PROTOTYPE(unsigned inb, (U16_t _port));
_PROTOTYPE(void outb, (U16_t _port, U8_t _value));
_PROTOTYPE(int allow_io, (unsigned long base, unsigned long num));
_PROTOTYPE(int disallow_io, (unsigned long base, unsigned long num));
_PROTOTYPE(unsigned int read_byte, (unsigned int port));
_PROTOTYPE(unsigned int read_word, (unsigned int port));
_PROTOTYPE(void write_byte, (unsigned int bytes, unsigned int port));
_PROTOTYPE(void write_word, (unsigned long word, unsigned int port));
_PROTOTYPE(void print_ports, (FILE* stream, unsigned long base, unsigned long num));
#else
int allow_io ( unsigned long base, unsigned long num );
int disallow_io ( unsigned long base, unsigned long num );

unsigned int read_byte ( unsigned int port );
unsigned int read_word ( unsigned int port );

void write_byte ( unsigned int byte, unsigned int port );
void write_word ( unsigned long word, unsigned int port );

void print_ports ( FILE* stream, unsigned long base, unsigned long num );
#endif

#endif /* _PORTLIB_H */

