/*****************************************************************************
 *  test2of2.c: here are functions for testing ictester device
 *  -=> this file is broken in two parts, because minix cc compiler have
 *  -=> problems to compile entire file 
 *  This is part of IC-tester program.
 *  Copyright (C) 2001, 2002  Silvio Klaic, sklaic@student.math.hr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *****************************************************************************/
#ifndef DOS
#include <unistd.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

#include "test.h"
#include "portlib.h"
#include "device.h"

int awritetest( unsigned int IO )/* test active writing at device */
{
int i,ret=0;
char DATA[17];

 for(i=0;(i<=7)&&(!ret);i++){/* test all pins if respond with GND */
  sprintf(DATA,"================");DATA[15-i]='0';/* set pin to GND */
  printf("Connect PIN %d and %d at test socket with resistor, press ENTER key to test...",i+1,16-i);getchar();
  if(portwrite(IO,DATA)){ret++;/* data select fail */
   printf("\r%79s\rTest fail, setting data on device fail during set %d pin.\n\
 => check ICs from IC2 to IC5, if they connected and working properly\n\
 => check leads on ictester board if they correctly soldered and connected\n\
 => check if all wires on 25pin connector are properly soldered\n"," ",i+1);}
  else {/* setting pass ok, test if data are ok */
   portread(IO,DATA);/* read data */
   if(DATA[i]!='0'){/* opa no reading? */
    ret++;/* opa, errors */
    printf("\r%79s\rTest fail, resistor which connects pin %d and %d is too strong.\n"," ",i+1,16-i);}
  }/* end else if portwrite */
  if(!ret){/* ok no errors continue */
  sprintf(DATA,"================");DATA[15-i]='0';DATA[i]='1';/* test */
  if(portwrite(IO,DATA)){ret++;/* data select fail */
   printf("\r%79s\rTest fail, setting data on device fail during set %d pin.\n\
 => check ICs from IC2 to IC5, if they connected and working properly\n\
 => check leads on ictester board if they correctly soldered and connected\n\
 => check if all wires on 25pin connector are properly soldered\n"," ",i+1);}
  else {/* setting pass ok, test if data are ok */
   portread(IO,DATA);/* read data */
   if(DATA[15-i]!='0'){/* opa short circuit? */
    ret++;/* opa, errors */
    printf("\r%79s\rTest fail, resistor which connects pin %d and %d is too weak.\n"," ",i+1,16-i);
   }else if(DATA[i]!='1'){ret++;/* oho setting not working */
     printf("\r%79s\rTest fail, there are some errors at pin %d.\n"," ",i+1);
     printf(" => check connections from pin %d at test socket thru transistor ",
i+1);
     switch (i){/* recognize position of transistors */
      case 0:printf("T14 and \nresistor R23 to pin 12 at IC3\n");break;/* 1 */
      case 1:printf("T13 and \nresistor R22 to pin 13 at IC3\n");break;/* 2 */
      case 2:printf("T10 and \nresistor R19 to pin 6 at IC3\n");break;/* 3 */
      case 3:printf("T9 and \nresistor R18 to pin 5 at IC3\n");break;/* 4 */
      case 4:printf("T6 and \nresistor R15 to pin 12 at IC2\n");break;/* 5 */
      case 5:printf("T5 and \nresistor R14 to pin 13 at IC2\n");break;/* 6 */
      case 6:printf("T2 and \nresistor R11 to pin 6 at IC2\n");break;/* 7 */
      case 7:printf("T1 and \nresistor R10 to pin 5 at IC2\n");break;/* 8 */
     }/* end switch */
   }/* end if not working */
  }/* end else if portwrite */
  }/*end if !ret */
  if(!ret){/* ok no errors continue */
  sprintf(DATA,"================");DATA[i]='0';DATA[15-i]='1';/* test */
  if(portwrite(IO,DATA)){ret++;/* data select fail */
   printf("\r%79s\rTest fail, setting data on device fail during set %d pin.\n\
 => check ics from IC2 to IC5, if they connected and working properly\n\
 => check leads on ictester board if they correctly soldered and connected\n\
 => check if all wires on 25pin connector are properly soldered\n"," ",16-i);}
  else {/* setting pass ok, test if data are ok */
   portread(IO,DATA);/* read data */
   if(DATA[i]!='0'){/* opa short circuit? */
    ret++;/* opa, errors */
    printf("\r%79s\rTest fail, resistor which connects pin %d and %d is too weak.\n"," ",i+1,16-i);
   }else if(DATA[15-i]!='1'){ret++;/* oho setting not working */
     printf("\r%79s\rTest fail, there are some errors at pin %d.\n"," ",16-i);
     printf(" => check connections from pin %d at test socket thru transistor ",
16-i);
     switch (15-i){/* recognize position of transistors */
      case 8:printf("T30 and \nresistor R39 to pin 12 at IC5\n");break;/* 9 */
      case 9:printf("T29 and \nresistor R38 to pin 13 at IC5\n");break;/* 10 */
      case 10:printf("T26 and \nresistor R35 to pin 6 at IC5\n");break;/* 11 */
      case 11:printf("T25 and \nresistor R34 to pin 5 at IC5\n");break;/* 12 */
      case 12:printf("T22 and \nresistor R31 to pin 12 at IC4\n");break;/* 13*/
      case 13:printf("T21 and \nresistor R30 to pin 13 at IC4\n");break;/* 14*/
      case 14:printf("T18 and \nresistor R27 to pin 6 at IC4\n");break;/* 15 */
      case 15:printf("T17 and \nresistor R26 to pin 5 at IC4\n");break;/* 16 */
     }/* end switch */
   }/* end if not working */
  }/* end else if portwrite */
  }/*end if !ret */
 }/* end for i */
 if(ret)
  printf(" => check transistors, if they connected and working properly\n\
 => check resistors, if they connected and working properly to transistors\n\
 => check ICs, if they connected and working properly to resistors\n\
 => check leads on ictester board if they correctly soldered and connected\n");
 return(ret);
}/* end awritetest() */

int rwritetest( unsigned int IO )/* test reading/writing at device */
{
int i,j,k,ret=0,lastpr=-1;
char DATA[17],ch[80];

/* jeah I know there are better ways, but I don't have time for them now */
 for(i=0;(i<=255)&&(!ret);i++){/* create first 8 pins */
  for(j=0;(j<=255)&&(!ret);j++){/* create last 8 pins */
   for(k=0;k<=15;k++) DATA[k]='0';/* fill with 0 */
   if(i & 1) DATA[0]='1'; if(i & 2) DATA[1]='1'; if(i & 4) DATA[2]='1';
   if(i & 8) DATA[3]='1'; if(i & 16) DATA[4]='1'; if(i & 32) DATA[5]='1';
   if(i & 64) DATA[6]='1'; if(i & 128) DATA[7]='1';/* set first 8 pins */
   if(j & 1) DATA[8]='1'; if(j & 2) DATA[9]='1'; if(j & 4) DATA[10]='1';
   if(j & 8) DATA[11]='1'; if(j & 16) DATA[12]='1'; if(j & 32) DATA[13]='1';
   if(j & 64) DATA[14]='1'; if(j & 128) DATA[15]='1';/* set last 8 pins */
   if(portwrite(IO,DATA)){ret++;/* data select fail */
    printf("\r%79s\rTest fail, setting data on device fail.\n\
 => check ICs from IC2 to IC5, if they connected and working properly\n\
 => check leads on ictester board if they correctly soldered and connected\n\
 => check if all wires on 25pin connector are properly soldered\n"," ");}
   else {/* setting pass ok, test if data are ok */
    portread(IO,ch);/* read data */
    for(k=0;k<=15;k++) if(DATA[k]!=ch[k]){ret++;/* opa, errors */
     printf("\r%79s\rTest fail, there are some errors at pin %d.\n"," ",k+1);}
   if(ret)
    printf(" => check transistors, if they connected and working properly\n\
 => check resistors, if they connected and working properly to transistors\n\
 => check leads on ictester board if they correctly soldered and connected\n");
   }/* end else if portwrite */
  }/* end for j */
  if(lastpr!=div(i*100,255).quot){/* there's changes, do update */
  sprintf(ch,"\rTesting: |%s", "====================================================");ch[div(i,5).quot+11]=0;lastpr=div(i*100,255).quot;
  printf("\r%-61s| %3d%%",ch,lastpr);fflush(NULL);}/* progress bar */
 }/* end for i */
 return(ret);
}/* end rwritetest() */

