/*****************************************************************************
 *  thyristo.c: here are functions for testing thyristors
 *  This is part of IC-tester program.
 *  Copyright (C) 2001,2002  Silvio Klaic, sklaic@student.math.hr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *****************************************************************************/

#include <stdio.h>
#include <ctype.h>
#include <string.h>

#include "rw.h"
#include "portlib.h"
#include "device.h"

/* this part isn't finis yet, here is testing if OCR element is thyristor */

short int thyristor_test(unsigned int IO)
{
char ch[19];
short int WhaT;

WhaT=1;portwrite(IO,"================");/* reset and do check */
portwrite(IO,"0===============");portread(IO,ch);ch[16]=0;
if(strcmp(ch,"0011111111111111")==0){/* A-G-K */
 portwrite(IO,"=0==============");portread(IO,ch);ch[16]=0;
 if(strcmp(ch,"0011111111111111")==0){/* continue scaning */
  portwrite(IO,"==0=============");portread(IO,ch);ch[16]=0;
  if(strcmp(ch,"1101111111111111")==0){/* possible A-G-K or A-K-G */
   /* check if under +5V working as A-G-K */
   portwrite(IO,"================");/* check if works A-K */
   portwrite(IO,"0=1=0=0===0=====");portread(IO,ch);ch[16]=0;
   ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
   if(strcmp(ch,"===1010111001111")==0){/* continue scaning */
    portwrite(IO,"011=0=0===0=====");portread(IO,ch);ch[16]=0;
    ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
    if(strcmp(ch,"===1000110001111")==0){/* continue scaning */
     portwrite(IO,"0=1=0=0===0=====");portread(IO,ch);ch[16]=0;
     ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
     if(strcmp(ch,"===1000110001111")==0){/* A-K works */
      portwrite(IO,"================");/* check if works K-A */
      portwrite(IO,"1=0=0=0===0=====");portread(IO,ch);ch[16]=0;
      ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
      if(strcmp(ch,"===1000110011111")==0){ /* continue scaning */
       portwrite(IO,"100=0=0===0=====");portread(IO,ch);ch[16]=0;
       ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
       if(strcmp(ch,"===1000111011111")==0){ /* check hold */
        portwrite(IO,"1=0=0=0===0=====");portread(IO,ch);ch[16]=0;
        ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
        if(strcmp(ch,"===1000110011111")==0) WhaT=50;/* K-A not work, ok */
        else WhaT=51;/* Work?????? Error not thyristor or burned? */
       }/* end if A-K hold works */
      }/* end if continue */
     }/* end if A-G-K */
     /* else error???? */
    }else if(strcmp(ch,"===1010110001111")==0){/* possible A-K-G */
     /* check if under +5V working as A-K-G */
     portwrite(IO,"================");/* check if works A-K */
     portwrite(IO,"=01=0=0===0=====");portread(IO,ch);ch[16]=0;
     ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
     if(strcmp(ch,"===1010111001111")==0){/* continue scaning */
      portwrite(IO,"101=0=0===0=====");portread(IO,ch);ch[16]=0;
      ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
      portwrite(IO,"=01=0=0===0=====");portread(IO,ch);ch[16]=0;
      ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
      if(strcmp(ch,"===1000110001111")==0){/* A-K works */
       portwrite(IO,"================");/* check if works K-A */
       portwrite(IO,"=10=0=0===0=====");portread(IO,ch);ch[16]=0;
       ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
       if(strcmp(ch,"===1000110011111")==0){ /* continue scaning */
        portwrite(IO,"010=0=0===0=====");portread(IO,ch);ch[16]=0;
        ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
        if(strcmp(ch,"===1010110011111")==0){ /* check hold */
         portwrite(IO,"=10=0=0===0=====");portread(IO,ch);ch[16]=0;
         ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
         if(strcmp(ch,"===1000110011111")==0) WhaT=40;/* K-A not work, ok */
         else WhaT=41;/* Work?????? error not thyristor or burned? */
        }/* end if A-K hold works */
       }/* end if continue */
      }/* end if A-K-G */
      /* else error???? */
     }/* end if continue */
    }/* end else if A-G-K or A-K-G */
   }/* else broboj ili neispravno spojen */
  }/* end if A-G-K or A-K-G */
 }/* end if continue */
}else if(strcmp(ch,"0101111111111111")==0){/* G-A-K or K-A-G */
 portwrite(IO,"=0==============");portread(IO,ch);ch[16]=0;
 if(strcmp(ch,"1011111111111111")==0){/* continue scaning */
  portwrite(IO,"==0=============");portread(IO,ch);ch[16]=0;
  if(strcmp(ch,"0101111111111111")==0){/* G-A-K thyristor */
   /* check if under +5V working as G-A-K */
   portwrite(IO,"================");/* check if works A-K */
   portwrite(IO,"01==0=0===0=====");portread(IO,ch);ch[16]=0;
   ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
   if(strcmp(ch,"===1010110011111")==0){/* continue scaning */
    portwrite(IO,"011=0=0===0=====");portread(IO,ch);ch[16]=0;
    ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
    if(strcmp(ch,"===1000110001111")==0){/* continue scaning */
     portwrite(IO,"01==0=0===0=====");portread(IO,ch);ch[16]=0;
     ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
     if(strcmp(ch,"===1000110001111")==0){/* A-K works */
      portwrite(IO,"================");/* check if works K-A */
      portwrite(IO,"10==0=0===0=====");portread(IO,ch);ch[16]=0;
      ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
      if(strcmp(ch,"===1000111001111")==0){ /* continue scaning */
       portwrite(IO,"100=0=0===0=====");portread(IO,ch);ch[16]=0;
       ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
       if(strcmp(ch,"===1000111011111")==0){ /* check hold */
        portwrite(IO,"10==0=0===0=====");portread(IO,ch);ch[16]=0;
        ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
        if(strcmp(ch,"===1000111001111")==0) WhaT=10;/* K-A not work, ok */
        else WhaT=11;/* Work?????? Error not thyristor or burned? */
       }/* end if A-K works */
      }/* end if continue */
     }/* end if A-K works */
     /* else error???? */
    }else if(strcmp(ch,"===1010110001111")==0){/* possible K-A-G */
     /* check if under +5V working as K-A-G */
     portwrite(IO,"================");/* check if works A-K */
     portwrite(IO,"=10=0=0===0=====");portread(IO,ch);ch[16]=0;
     ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
     if(strcmp(ch,"===1010110011111")==0){/* continue scaning */
      portwrite(IO,"110=0=0===0=====");portread(IO,ch);ch[16]=0;
      ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
      if(strcmp(ch,"===1000110001111")==0){/* continue scaning */
       portwrite(IO,"=10=0=0===0=====");portread(IO,ch);ch[16]=0;
       ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
       if(strcmp(ch,"===1000110001111")==0){/* A-K works */
        portwrite(IO,"================");/* check if works K-A */
        portwrite(IO,"=01=0=0===0=====");portread(IO,ch);ch[16]=0;
        ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
        if(strcmp(ch,"===1000111001111")==0){ /* continue scaning */
         portwrite(IO,"001=0=0===0=====");portread(IO,ch);ch[16]=0;
         ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
         if(strcmp(ch,"===1010111001111")==0){ /* check hold */
          portwrite(IO,"=01=0=0===0=====");portread(IO,ch);ch[16]=0;
          ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
          if(strcmp(ch,"===1000111001111")==0) WhaT=20;/* K-A not work, ok */
          else WhaT=21;/* Work?????? Error not thyristor or burned? */
         }/* end if A-K works */
        }/* end if continue */
       }/* end if A-K works */
       /* else error???? */
      }/* neispravni element */
     }/* else broboj ili neispravno spojen */
    }/* end else if G-A-K or K-A-G */
   }/* else broboj ili neispravno spojen */
  }/* end if continue */
 }/* end if continue */
}else if(strcmp(ch,"0111111111111111")==0){/* Thyristor G-K-A or K-G-A */
 portwrite(IO,"=0==============");portread(IO,ch);ch[16]=0;
 if(strcmp(ch,"1001111111111111")==0){/* continue scaning */
  portwrite(IO,"==0=============");portread(IO,ch);ch[16]=0;
  if(strcmp(ch,"1001111111111111")==0){/* continue scaning */
   /* check if under +5V working as G-K-A */
   portwrite(IO,"================");/* check if works A-K */
   portwrite(IO,"10==0=0===0=====");portread(IO,ch);ch[16]=0;
   ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
   if(strcmp(ch,"===1000111011111")==0){/* continue scaning */
    portwrite(IO,"101=0=0===0=====");portread(IO,ch);ch[16]=0;
    ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
    if(strcmp(ch,"===1000110001111")==0){/* continue scaning */
     portwrite(IO,"10==0=0===0=====");portread(IO,ch);ch[16]=0;
     ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
     if(strcmp(ch,"===1000110001111")==0){/* A-K works */
      portwrite(IO,"================");/* check if works K-A */
      portwrite(IO,"01==0=0===0=====");portread(IO,ch);ch[16]=0;
      ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
      if(strcmp(ch,"===1010110001111")==0){ /* continue scaning */
       portwrite(IO,"010=0=0===0=====");portread(IO,ch);ch[16]=0;
       ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
       if(strcmp(ch,"===1010110011111")==0){ /* check hold */
        portwrite(IO,"01==0=0===0=====");portread(IO,ch);ch[16]=0;
        ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
        if(strcmp(ch,"===1010110001111")==0) WhaT=80;/* K-A not work, ok */
        else WhaT=81;/* Work?????? Error not thyristor or burned? */
       }/* end if A-K works */
      }/* end if continue */
     }/* end if G-K-A */
     /* else error???? */
    }else if(strcmp(ch,"===1000111001111")==0){/* possible K-G-A */
     /* check if under +5V working as K-G-A */
     portwrite(IO,"================");/* check if works A-K */
     portwrite(IO,"1=0=0=0===0=====");portread(IO,ch);ch[16]=0;
     ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
     if(strcmp(ch,"===1000111011111")==0){/* continue scaning */
      portwrite(IO,"110=0=0===0=====");portread(IO,ch);ch[16]=0;
      ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
      if(strcmp(ch,"===1000110001111")==0){/* continue scaning */
       portwrite(IO,"1=0=0=0===0=====");portread(IO,ch);ch[16]=0;
       ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
       if(strcmp(ch,"===1000110001111")==0){/* A-K works */
        portwrite(IO,"================");/* check if works K-A */
        portwrite(IO,"0=1=0=0===0=====");portread(IO,ch);ch[16]=0;
        ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
        if(strcmp(ch,"===1010110001111")==0){ /* continue scaning */
         portwrite(IO,"001=0=0===0=====");portread(IO,ch);ch[16]=0;
         ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
         if(strcmp(ch,"===1010111001111")==0){ /* check hold */
          portwrite(IO,"0=1=0=0===0=====");portread(IO,ch);ch[16]=0;
          ch[0]='=';ch[1]='=';ch[2]='=';/* ignore set bits */
          if(strcmp(ch,"===1010110001111")==0) WhaT=70;/* K-A not work, ok */
          else WhaT=71;/* Work?????? Error not thyristor or burned? */
         }/* end if A-K works */
        }/* end if continue */
       }/* end if K-G-A */
       /* else error???? */
      }/* end else if K-G-A */
     }/* else broboj ili neispravno spojen */
    }/* end else if K-G-A */
   }/* else broboj ili neispravno spojen */
  }/* end if continue */
 }/* end if continue */
}/* end if triac */
    printf("|  -=-    -=-    -=-  |\n| pin 1  pin 2  pin 3 |\n\
`---|------|------|---'\n");
switch (WhaT){/* check results */
 case 0:/* error during read or write */
       printf("Error: Detecting power on some pins and there shouldn't be\
 any!\nUse -to option and do test OCR/Diode device to make sure that's\
 working ok.\n");break;
 case 1:/* not connected properly */
	printf("\nOCR element not connected properly on test socket or it's\
 burn out.\n\n");break;
 case 10:/* thyristor G-A-K working ok */
        printf("   (G)    (A)    (K)\n    |      \\__|\\|_/\n\
    |         |/|\\\n    `------------'\n\nThyristor working 100%%.\n\n");break;
 case 11:/* not a thyristor G-A-K or it's burned */
        printf("What's that not thyristor or it's burned?\n");break; 
 case 20:/* thyristor K-A-G working ok */
        printf("   (K)    (A)    (G)\n    \\__|/|_/      |\n\
      /|\\|        |\n      `-----------'\n\nThyristor working 100%%.\n\n");break;
 case 21:/* not a thyristor K-A-G or it's burned */
        printf("What's that not thyristor or it's burned?\n");break; 
 case 40:/* thyristor A-K-G working ok */
        printf("   (A)    (K)    (G)\n    |      |      |\n\
    \\__|\\|/_______/\n       |/|\n\nThyristor working 100%%.\n\n");break;
 case 41:/* not a thyristor A-K-G or it's burned */
        printf("What's that not thyristor or it's burned?\n");break; 
 case 50:/* thyristor A-G-K working ok */
        printf("  (A)    (G)    (K)\n    |      |      |\n\
    \\__|\\|/_______/\n       |/|\n\nThyristor working 100%%.\n\n");break;
 case 51:/* not a thyristor A-G-K or it's burned */
        printf("What's that not thyristor or it's burned?\n");break; 
 case 70:/* thyristor K-G-A working ok */
        printf("   (K)    (G)    (A)\n    |      |      |\n\
    \\_______\\|/|__/\n             |\\|\n\nThyristor working 100%%.\n\n");break;
 case 71:/* not a thyristor K-G-A or it's burned */
        printf("What's that not thyristor or it's burned?\n");break; 
 case 80:/* thyristor G-K-A working ok */
        printf("   (G)    (K)    (A)\n    |      \\__|\\|_/\n\
    |         |/|\\\n    `------------'\n\nThyristor working 100%%.\n\n");break;
 case 81:/* not a thyristor G-K-A or it's burned */
        printf("What's that not thyristor or it's burned?\n");break; 
 default:/* error, not OCR connected at pins 1, 2 and 3 */
        printf("Error t(%d): At test socket isn't OCR element, aborting test.\n",WhaT);
        break;
}/* end switch */
return(99);/* return ok value */
}/* end thyristor_test() */

